#include <stdio.h>
#include <fcntl.h>
#include <linux/joystick.h>

extern int errno;

main(argc,argv)
int argc;
char *argv[];
{
	int			fd, jsn, ln, tmp;
	long			tmpl;
	struct JS_DATA_TYPE	js;
	struct JS_DATA_TYPE_LONG	jsl;
	char			file[20];

	if (argc != 2)
		usage();
	if ((jsn=atoi(argv[1])) != 0 && jsn != 1)
		usage();
	sprintf(file,"/dev/js%d",jsn);
	printf("Trying %s\n",file);
	if ((fd=open(file,O_RDONLY)) < 0)
		die("Error opening",file);
	tmp = 30000;
	if (ioctl(fd,JS_SET_TIMEOUT,&tmp) == -1)
		die("Joystick ioctl failed","");
	if (ioctl(fd,JS_GET_TIMEOUT,&tmp) == -1)
		die("Joystick ioctl failed","");
	printf("Timeout value=%d\n",tmp);
	if (ioctl(fd,JS_GET_TIMELIMIT,&tmpl) == -1)
		die("Joystick ioctl failed","");
	printf("Timelimit value=%ld\nSetting Timelimit= 1\n",tmpl);
	tmpl=1;
	if (ioctl(fd,JS_SET_TIMELIMIT,&tmpl) == -1)
		die("Joystick ioctl failed","");
	if (ioctl(fd,JS_GET_CAL,&js) == -1)
		die("Joystick ioctl failed","");
	printf("Current correction:%d,%d\n",js.x,js.y);
	printf("Move joystick to lower right and press either button\n");
	while ((read(fd,&jsl,JS_RETURN_LONG) > 0) && jsl.buttons == 0x00)
		printf("Got x=%04x, y=%04x\r",jsl.x,jsl.y, jsl.x2, jsl.y2);
	for(tmp=0;jsl.x > 0xff;tmp++,jsl.x=js.x >> 1)
		;
	js.x=tmp;
	for(tmp=0;jsl.y > 0xff;tmp++,jsl.y=jsl.y >> 1)
		;
	js.y=tmp;
	printf("Setting correction:%d,%d\n",js.x,js.y);
	if (ioctl(fd,JS_SET_CAL,&js) == -1)
		die("Joystick ioctl failed","");
	if (ioctl(fd,JS_GET_CAL,&js) == -1)
		die("Joystick ioctl failed","");
	printf("Verify Correction:%d,%d\n",js.x,js.y);
	while (1)
		if (read(fd,&jsl,JS_RETURN_LONG) != JS_RETURN_LONG)
			printf("\rread failed %d   ",errno);
		else {
			fprintf(stdout,"\r%x %5u %5u %5u %5u ",
				jsl.buttons,jsl.x,jsl.y, jsl.x2, jsl.y2);
			fflush(stdout);
		}
	(void) close(fd);
}

int usage()
{
	die("Usage: jscal <0|1>\n","");
}

die(s1,s2)
char *s1,*s2;
{
	printf("%s %s %d\n",s1,s2,errno);
	exit(-1);
}
